org.licas.def.gui

## Interface ServiceGuiDef

-     public interface ServiceGuiDef

  This interface must be implemented by any GUI form that wants to be recognised as a GUI interface to a licas service.
  Author:
    Kieran Greer

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `closeGui()` Shut the GUI down.
    `boolean` | `getAutoHide()` Get value indicating if GUI should be auto-hidden.
    `java.lang.String` | `getID()` Get the related service's unique id.
    `java.awt.Point` | `getLastLocation()` Get the last recorded location for the GUI.
    `void` | `initialiseAndOpen(java.lang.String serviceUuid, java.lang.String serviceType, java.lang.String servicePassword, java.lang.String serviceAdminKey, org.licas_xml.abs.Element serviceUrl, java.lang.String serverPassword, MainGuiDef theMainGui)` Initialise the GUI interface, open it and make it visible for use.
    `boolean` | `isInside(int px, int py)` Return true if the px-py coord is inside the GUI frame with relation to the whole screen.
    `void` | `setAutoHide(boolean thisHide)` Set value indicating if auto-hide the GUI from view.
    `void` | `showHide(int px, int py)` Show or hide the GUI depending on conditions.

- - ### Method Detail

    - #### getID

          java.lang.String getID()

      Get the related service's unique id.
      Returns:
        the service's uuid.

    - #### initialiseAndOpen

          void initialiseAndOpen(java.lang.String serviceUuid,
                                 java.lang.String serviceType,
                                 java.lang.String servicePassword,
                                 java.lang.String serviceAdminKey,
                                 org.licas_xml.abs.Element serviceUrl,
                                 java.lang.String serverPassword,
                                 MainGuiDef theMainGui)
                          throws java.lang.Exception

      Initialise the GUI interface, open it and make it visible for use.
      Parameters:
        `serviceUuid` - the uuid of the service the GUI relates to.
        `serviceType` - the type of service the GUI relates to.
        `servicePassword` - the password for calling the service.
        `serviceAdminKey` - the service admin key.
        `serviceUrl` - the full url path to the service that the GUI is for. The server url is constructed from this.
        `serverPassword` - the local server password.
        `theMainGui` - a reference to the main gui.
      Throws:
        `java.lang.Exception` - any error.

    - #### setAutoHide

          void setAutoHide(boolean thisHide)

      Set value indicating if auto-hide the GUI from view.
      Parameters:
        `thisHide` - true if hide, false otherwise.

    - #### getAutoHide

          boolean getAutoHide()

      Get value indicating if GUI should be auto-hidden.
      Returns:
        the value of hide.

    - #### showHide

          void showHide(int px,
                        int py)

      Show or hide the GUI depending on conditions.
      Parameters:
        `px` - the x-coord of the mouse.
        `py` - the y-coord of the mouse.

    - #### isInside

          boolean isInside(int px,
                           int py)

      Return true if the px-py coord is inside the GUI frame with relation to the whole screen.
      Parameters:
        `px` - the px-coord.
        `py` - the py-coord.
      Returns:
        true if inside the gui frame, false otherwise.

    - #### getLastLocation

          java.awt.Point getLastLocation()

      Get the last recorded location for the GUI.
      Returns:
        the location as a Point.

    - #### closeGui

          void closeGui()

      Shut the GUI down.